.686
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

INCLUDE \masm32\include\windows.inc

INCLUDE \masm32\include\kernel32.inc
INCLUDE \masm32\include\user32.inc
INCLUDE \masm32\include\gdi32.inc
INCLUDE \masm32\include\DateTime.inc

INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\gdi32.lib
INCLUDELIB \masm32\lib\DateTime.lib

IDI_ICON1 EQU 1 
IDC_TIMER EQU 2
IDM_ABOUT EQU 3

CR        EQU 13
LF        EQU 10

WinW      EQU 400
WinH      EQU 180

WinMain PROTO hInst:HINSTANCE, hPrevInst:HINSTANCE, pszCmdLine:PTR BYTE, CmdShow:SDWORD
GetFontHandle PROTO hght:DWORD, wdth:DWORD, wght:DWORD, pszFacename:PTR BYTE

RGB MACRO red,green,blue 
    xor  eax,eax 
    mov  ah,blue 
    shl  eax,8 
    mov  ah,green 
    mov  al,red 
ENDM

.DATA

    ClassName   BYTE "LocalClock", 0
    AppName     BYTE "Local Clock", 0
    strFacename BYTE "Consolas", 0
    ;strFacename BYTE "Courier New", 0    ; If you don't have Consolas use a different font
    MenuName    BYTE "LocalClock", 0
    strAbout    BYTE "Greg Lyon", CR, LF, "January 2012", CR, LF, "Written in MASM32", 0 
    
    strBufferT  BYTE 16 DUP(0)
    strBufferD  BYTE 32 DUP(0)
  
    strTimeZone BYTE 64 dup(0)
 
    dtLocal     DATETIME 0

.DATA?

    hInstance   HINSTANCE ?
    CommandLine LPSTR ?
    TimerID     UINT  ?
    hFont1      HFONT ?
    hFont2      HFONT ?
    hMenu       HMENU ?

    ps          PAINTSTRUCT <?>
    rect        RECT <?>
    hdc         HDC ?

    ; Off-screen DC
    hdcMem      HDC ?
    hbmMem      HBITMAP ?
    hbrBkGnd    HBRUSH ?


.CODE

start:

    INVOKE GetModuleHandle, NULL
    mov    hInstance,eax
    INVOKE GetCommandLine
    mov    CommandLine, eax
    INVOKE WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
    INVOKE ExitProcess, eax
    
;-----------------------------------------------------------------------------
WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, pszCmdLine:PTR BYTE, CmdShow:SDWORD

    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    LOCAL hwnd:HWND
    
    INVOKE LoadMenu, hInst, ADDR MenuName 
    mov hMenu, eax

    mov   wc.cbSize,SIZEOF WNDCLASSEX
    mov   wc.style, CS_HREDRAW or CS_VREDRAW
    mov   wc.lpfnWndProc, OFFSET WndProc
    mov   wc.cbClsExtra,NULL
    mov   wc.cbWndExtra,NULL
    push  hInst
    pop   wc.hInstance
    mov   wc.hbrBackground,COLOR_WINDOW+1
    mov   wc.lpszMenuName, OFFSET MenuName
    mov   wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, hInst, IDI_ICON1
    mov   wc.hIcon,eax
    mov   wc.hIconSm,eax
    INVOKE LoadCursor,NULL,IDC_ARROW
    mov   wc.hCursor,eax

    INVOKE RegisterClassEx, addr wc

    INVOKE CreateWindowEx,\
        NULL,\
        ADDR ClassName,\
        ADDR AppName,\
        WS_SYSMENU or WS_MINIMIZEBOX,\
        CW_USEDEFAULT,\
        CW_USEDEFAULT,\
        WinW,\
        WinH,\
        NULL,\
        hMenu,\
        hInst,\
        NULL
           
    mov   hwnd,eax

    INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
    INVOKE UpdateWindow, hwnd

    .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL, 0, 0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
    .ENDW

    mov     eax,msg.wParam

    ret

WinMain ENDP
;-----------------------------------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
   
      .IF uMsg == WM_TIMER

            INVOKE IsIconic, hWnd
            .IF eax == 1
                INVOKE GetLocalDateTime, ADDR dtLocal
                INVOKE DateTimeToTimeString, ADDR dtLocal, ADDR strBufferT
                INVOKE SetWindowText, hWnd, ADDR strBufferT
             .ELSE
                INVOKE InvalidateRect, hWnd, NULL, TRUE
            .ENDIF    

    .ELSEIF uMsg == WM_PAINT

            INVOKE BeginPaint, hWnd, ADDR ps
            mov hdc, eax 

            ; Get the time and date
            
            INVOKE GetLocalDateTime, ADDR dtLocal
            
            ; Convert the time and date to strings
            
            INVOKE DateTimeToTimeString, ADDR dtLocal, ADDR strBufferT
            INVOKE DateTimeToDateStringLong, ADDR dtLocal, ADDR strBufferD
            
            ; Get the size of the client rectangle

            INVOKE GetClientRect, hWnd, ADDR rect
            
            ; Select the bitmap into the off-screen DC.
              
            INVOKE SelectObject, hdcMem, hbmMem
                        
            ; Erase the background.
                
            INVOKE FillRect, hdcMem, ADDR rect, hbrBkGnd
            
            ; ** Time **
            ; Select font 1
            
            INVOKE SelectObject, hdcMem, hFont1
            
            ; Draw the image into the off-screen DC
            
            RGB 255,255,255                         ; backgound color
            INVOKE SetBkColor, hdcMem, eax
            
            RGB 0,64,128                            ; text color
            INVOKE SetTextColor, hdcMem, eax
            
            INVOKE DrawText, hdcMem, ADDR strBufferT, -1, ADDR rect, DT_CENTER or DT_VCENTER or DT_SINGLELINE

            ; ** Date **
            ; Select font 2
            INVOKE SelectObject, hdcMem, hFont2
            
            ; Draw the image into the off-screen DC
            
            RGB 255,255,255                         ; backgound color
            INVOKE SetBkColor, hdcMem, eax
            
            RGB 111,0,111                           ; text color
            INVOKE SetTextColor, hdcMem, eax
            
            INVOKE DrawText, hdcMem, ADDR strBufferD, -1, ADDR rect, DT_CENTER or DT_BOTTOM or DT_SINGLELINE
            
            ; BitBlt the changes to the screen DC
            
            INVOKE BitBlt, hdc, rect.left, rect.top, WinW, WinH, hdcMem, 0, 0, SRCCOPY 
            
            INVOKE EndPaint, hWnd, ADDR ps
            
      .ELSEIF uMsg == WM_ERASEBKGND 
      
      mov eax, 1
      ret            
            
      .ELSEIF uMsg == WM_SIZE
      
            mov eax, wParam
            
            .IF ax ==  SIZE_RESTORED
                INVOKE SetWindowText, hWnd, ADDR strTimeZone
            .ELSEIF ax == SIZE_MINIMIZED
                INVOKE GetLocalDateTime, ADDR dtLocal
                INVOKE DateTimeToTimeString, ADDR dtLocal, ADDR strBufferT
                INVOKE SetWindowText, hWnd, ADDR strBufferT
            .ENDIF              

      .ELSEIF uMsg == WM_CREATE
      
            ; Create a timer

            INVOKE SetTimer, hWnd, IDC_TIMER, 1000, NULL
            mov TimerID, eax
            
            ; Create an off-screen DC
                        
            INVOKE GetDC, hWnd
            mov hdc, eax
            
            INVOKE CreateCompatibleDC, hdc
            mov hdcMem, eax
            
            ; Create an off-screen bitmap.
            
            INVOKE CreateCompatibleBitmap, hdc, WinW, WinH
            mov hbmMem, eax
            
            ; Create a brush for the background
            
            INVOKE GetSysColor, COLOR_WINDOW
            INVOKE CreateSolidBrush, eax
            mov hbrBkGnd, eax
            
            ; Create three different fonts
                         
            INVOKE GetFontHandle, 65, 0, 700, ADDR strFacename
            mov hFont1, eax

            INVOKE GetFontHandle, 25, 0, 700, ADDR strFacename
            mov hFont2, eax
                     
            INVOKE CurrentTimeZoneName, ADDR strTimeZone
                                  
            INVOKE SetWindowText, hWnd, ADDR strTimeZone
          
    .ELSEIF uMsg == WM_COMMAND
    
            mov eax, wParam 

            .IF ax == IDM_ABOUT
                INVOKE MessageBox, NULL, ADDR strAbout, ADDR AppName, MB_OK 
            .ENDIF 

    .ELSEIF uMsg == WM_DESTROY

            INVOKE KillTimer, hWnd, TimerID
            INVOKE DeleteObject, hFont1
            INVOKE DeleteObject, hFont2
            INVOKE DeleteDC, hdc
            
            INVOKE DeleteObject, hbrBkGnd
            INVOKE DeleteObject, hbmMem
            INVOKE DeleteDC, hdcMem
                        
            INVOKE PostQuitMessage,NULL
            
    .ELSE

        INVOKE DefWindowProc,hWnd,uMsg,wParam,lParam
        ret

    .ENDIF

    xor    eax,eax

    ret

WndProc ENDP
;-----------------------------------------------------------------------------
GetFontHandle PROC hght:DWORD, wdth:DWORD, wght:DWORD, pszFacename:PTR BYTE

        INVOKE CreateFont,\
          hght,\
          wdth,\
          0,\
          0,\
          wght,\
          FALSE,\
          FALSE,\
          FALSE,\
          ANSI_CHARSET,\
          0,\
          0,\
          PROOF_QUALITY,\
          DEFAULT_PITCH,\
          pszFacename

          ret
          
GetFontHandle ENDP
;-----------------------------------------------------------------------------
END start
